// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { LogError } from "../../../../core/decorator/LogErrorDecorator";
import { IdentityRegistryRequest, OnchainIDRequest, SetIdentityRegistryRequest, SetOnchainIDRequest, } from "../../request";
import ValidatedRequest from "../../../../core/validation/ValidatedArgs";
import { SetOnchainIDCommand } from "../../../../app/usecase/command/security/operations/tokenMetadata/setOnchainID/SetOnchainIDCommand";
import { SetIdentityRegistryCommand } from "../../../../app/usecase/command/security/identityRegistry/setIdentityRegistry/SetIdentityRegistryCommand";
import { IdentityRegistryQuery } from "../../../../app/usecase/query/security/identityRegistry/IdentityRegistryQuery";
import { OnchainIDQuery } from "../../../../app/usecase/query/security/tokenMetadata/onchainId/OnchainIDQuery";
import { BaseSecurityInPort } from "../BaseSecurityInPort";
export class SecurityInPortIdentity extends BaseSecurityInPort {
    async setOnchainID(request) {
        const { securityId, onchainID } = request;
        ValidatedRequest.handleValidation("SetOnchainIDRequest", request);
        return await this.commandBus.execute(new SetOnchainIDCommand(securityId, onchainID));
    }
    async setIdentityRegistry(request) {
        const { securityId, identityRegistry } = request;
        ValidatedRequest.handleValidation("SetIdentityRegistryRequest", request);
        return await this.commandBus.execute(new SetIdentityRegistryCommand(securityId, identityRegistry));
    }
    async identityRegistry(request) {
        const { securityId } = request;
        ValidatedRequest.handleValidation("IdentityRegistryRequest", request);
        return (await this.queryBus.execute(new IdentityRegistryQuery(securityId))).payload;
    }
    async onchainID(request) {
        const { securityId } = request;
        ValidatedRequest.handleValidation("OnchainIDRequest", request);
        return (await this.queryBus.execute(new OnchainIDQuery(securityId))).payload;
    }
}
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [SetOnchainIDRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortIdentity.prototype, "setOnchainID", null);
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [SetIdentityRegistryRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortIdentity.prototype, "setIdentityRegistry", null);
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [IdentityRegistryRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortIdentity.prototype, "identityRegistry", null);
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [OnchainIDRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortIdentity.prototype, "onchainID", null);
